"use strict";

class ChooseTheWeather {
    constructor() {
        this.mod = "Revingly-BraceTheStorm";
        Logger.info(`Loading: ${this.mod}`);
        WeatherController.generateWeather = this.chooseWeather.bind(this);
    }

    chooseWeather(data) {
        // Get the config file for the weather
        const { weatherTypes, weather, random, overrides} = require('./config.json');
        // Get the weather sets to choose from
        const weatherSets = require('./weatherSet.json');
        // Put the choosen weather from the config in a variable
        let choosenWeather;

        if (random) {
            const randomIndex = Math.floor(Math.random() * weatherTypes.length);
            choosenWeather = weatherSets[weatherTypes[randomIndex]];
        } else {
            choosenWeather = weatherSets[weather];
        }

        if (Object.keys(overrides).length > 0) { // check if overrides object has key/values to iterate through
            for (const weatherItem in overrides) {
                choosenWeather[weatherItem] = overrides[weatherItem];
            }
        }

        this.createWeather(choosenWeather, data);

        return data;
    }

    createWeather(choosenWeather, data) {
        Object.entries(choosenWeather).forEach(([key, value]) => {
            data.weather[key] = value;
        });
    }
}

module.exports.Mod = ChooseTheWeather;